%define ver 3.1

Summary:	Partitioning, load balancing and data-management services
Name:		zoltan
Version:	%{ver}
Release:	2
License:	LGPL
Group:		Applications/Library
Source:		zoltan-%{ver}.tar.bz2
Patch:		zoltan-3.1-gcc296.patch
URL:		http://www.cs.sandia.gov/Zoltan
BuildRoot:	/var/tmp/%{name}-%{version}-root-%(id -u -n)
BuildArch:	i386 x86_64
Requires:	make
Prefix:		/usr

%description
Zoltan is a collection of data management services for unstructured, adaptive
and dynamic applications. It includes a suite of parallel partitioning
algorithms, data migration tools, parallel graph coloring tools, distributed
data directories, unstructured communication services, and dynamic memory
management tools. Zoltan's data-structure neutral design allows it to be used
by a variety of applications without imposing restrictions on application data
structures. Its object-based interface provides a simple and inexpensive way
for application developers to use the library and researchers to make new
capabilities available under a common interface.

%prep
%setup -q -n Zoltan_v%{ver}
%patch -p1

%build
./configure -C --disable-default-packages --enable-mpi --with-mpi-compilers \
	--disable-fortran --enable-zoltan --with-gnumake
cd src
# Hacky: create customized mpicc and mpicxx
mkdir bin
mpicc=`which mpicc`
mpicxx=`which mpicxx`
cat << END >bin/mpicc
$mpicc -fPIC "\$@"
END
cat << END >bin/mpicxx
$mpicxx -fPIC "\$@"
END
chmod a+x bin/mpicc bin/mpicxx
export PATH=`pwd`/bin:${PATH}
gmake zoltan

%install
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT/{%{_docdir}/zoltan,%{_includedir},%{_libdir}}
/bin/cp -pf GNU_Lesser_GPL.txt Known_Problems VERSION doc/Zoltan_pdf/*.pdf \
	$RPM_BUILD_ROOT/%{_docdir}/zoltan
cd src
/bin/cp -pf README $RPM_BUILD_ROOT/%{_docdir}/zoltan
/bin/cp -pf include/zoltan*.h $RPM_BUILD_ROOT/%{_includedir}
rm -rf tmp
mkdir tmp
cd tmp
for l in ../Obj_generic/*.a; do
    ar x $l
    i=`basename $l`
    gcc -shared -o $RPM_BUILD_ROOT/%{_libdir}/${i%.a}.so *.o
    rm -f *.o
done
cd ..
rm -rf tmp
/bin/chmod -R a+rX $RPM_BUILD_ROOT/%{prefix}

%clean
[ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%post
/sbin/ldconfig

%postun
/sbin/ldconfig

%files
%{_docdir}/zoltan
%{_includedir}
%{_libdir}

%changelog
* Fri Dec 28 2007 Zhang Linbo <zlb@lsec.cc.ac.cn>
- Created the RPM package.
